
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ajax提交session超时跳转页面使用全局的方法来处理 / 憋错料</title>

    <meta name="description" content="ajax提交session超时跳转页面使用全局的方法来处理 来自:http://www.jb51.net/article/43770.htm 如果是ajax提交,超时时从服务器发出的跳转命令就不会起作用,所以如果是session超时,而且是在ajax请求,就在响应头里,再用一个全局的方法来处理session超时要跳转的页面. 在过滤器中写入如下方法:(未测试) public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws I">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">ajax提交session超时跳转页面使用全局的方法来处理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>来自：http://www.jb51.net/article/43770.htm</p>
<p>如果是ajax提交，超时时从服务器发出的跳转命令就不会起作用，所以如果是session超时，而且是在ajax请求，就在响应头里，再用一个全局的方法来处理session超时要跳转的页面。</p>
<p>在过滤器中写入如下方法：（未测试）</p>
<pre>public void doFilter(ServletRequest request, ServletResponse response,
FilterChain chain) throws IOException, ServletException {
HttpServletRequest httprequest = (HttpServletRequest) request;
HttpServletResponse httpresponse = (HttpServletResponse) response;
String url = httprequest.getRequestURL().toString();
if (httprequest.getSession()== null) {
if (httprequest.getHeader("x-requested-with") != null
&amp;&amp; httprequest.getHeader("x-requested-with").equals(
"XMLHttpRequest")) { // ajax请求
httpresponse.setHeader("sessionstatus", "timeout");
} else {
httpresponse.sendRedirect("/test/index.jsp");
return;
}
} else {
chain.doFilter(request, response);
}
} </pre>
<p>这样，如果session超时，而且是ajax请求，就会在响应头里，sessionstatus有一个timeout;再用一个全局的方法来处理session超时要跳转的页面</p>
<p><strong>jquery可以用$.ajaxSetup方法，ext也有类似的方法：（测试有效）</strong></p>
<pre>//全局的ajax访问，处理ajax清求时sesion超时
$.ajaxSetup({
contentType : "application/x-www-form-urlencoded;charset=utf-8",
complete : function(XMLHttpRequest, textStatus) {
var sessionstatus = XMLHttpRequest.getResponseHeader("sessionstatus"); // 通过XMLHttpRequest取得响应头，sessionstatus，
if (sessionstatus == "timeout") {
// 如果超时就处理 ，指定要跳转的页面
window.location.replace("/test/index.jsp");
}
}
}); </pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-02 04:45:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>ajax提交session超时跳转页面使用全局的方法来处理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgyPEn3.html" rel="bookmark">Ajax 提交session实效跳转到完整的登陆页面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(function($){ // 保存原有的jquery ajax; var $_ajax = $.ajax; $.ajax = function(options){ var originalSuccess, mySuccess, success_context; if (options.success) { // save reference to original success callback originalSuccess = options.success; success_cont			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49vJ81M.html" rel="bookmark">webix&plus;springmvc session超时跳转登录页面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2016-10-30 13:11:56 引言 最近做项目,发现ajax请求不能在服务器中直接重定向到登录页面.查了些资料发现jquery的ajax请求有人给出了方法.但是webix的ajax请求和jquery的有些区别.这里模仿jquery的处理方式实现webix的ajax请求session超时跳转. 具体的做法: 1.查看webix.js源码发现webix.ajax只有请求前的监听函数 &quot;onBeforeAjax&quot;, 要做到获取返回状态跳转登录页面必须要有个返回的监听函数,但是源码没			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rOvq74.html" rel="bookmark">Ajax请求Session超时解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web前端js代码: $.ajaxSetup({ contentType : &quot;application/x-www-form-urlencoded;charset=utf-8&quot;, complete : function(xhr, textStatus) { if (xhr.status == 520) {//如果返回状态码是520 window.location..reload();//刷新页面,执行登录逻辑 return; } } }); java代码: 1. 写一个filter i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGxgYo0.html" rel="bookmark">asp&period;net跳转页面的三种方法比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目前,对于学习asp.net的很多朋友来讲,实现跳转页面的方法还不是很了解.本文将为朋友们介绍利用asp.net跳转页面的三种方法,并对其之间的形式进行比较,希望能够对朋友们有所帮助. ASP.NET发展起源 1 ASP.NET的前身ASP技术,是在IIS 2.0上首次推出(Windows NT 3.51),当时与 ADO 1.0 一起推出,在IIS 3.0 (Windows NT 4.0)发扬光大,成为服务器端应用程序的热门开发工具,微软还特别为它量身打造了Visual InterDev开发工			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k6lqdM.html" rel="bookmark">esayui session 超时跳转登录页面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 代码部分: ① web.XML部分配置代码 &lt;!-- filter 权限认证 只对amf请求过滤 --&gt;&lt;filter&gt; &lt;filter-name&gt;authFilter&lt;/filter-name&gt; &lt;filter-class&gt;com.lactec.framework.ac.filter.AuthFilter&lt;/filter-class&gt;&lt;/filter&gt; &lt;filter-mapping&gt; &lt;filter			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38KzOA0.html" rel="bookmark">jQuery easyui Session 超时返回登录页面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明:测试设置失效时间为1分钟,登录成功后1分钟去点击操作处罚事件,执行①连接到com.lactec.framework.ac.filter.AuthFilter这个类判断执行的action操作. 判断session是否为空,超时就返回,我用的是ajax请求:如果是ajax请求响应头会有,x-requested-with: 设置: rep.setHeader(&quot;sessionstatus&quot;, &quot;timeout&quot;);//在响应头设置session状态        			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qk8NGM.html" rel="bookmark">一些理解-过滤器，拦截器，ajax提交后不跳转，document&period;location&period;href无效，回调函数。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.struts2中过滤器和拦截器的工作流程: request--&gt;执行自定义过滤器doFilter方法中的chain.doFilter()方法前的代码--&gt;执行默认过滤器doFilter方法中的chain.doFilter()方法前的代码--&gt;执行默认拦截器--&gt;执行自定义拦截器--&gt;访问服务器资源(action,css,html,jsp...)--&gt;执行自定义拦截器--&gt;执行默认拦截器--&gt;执行默认过滤器的doFilter方法中chain.doFilte			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGRVOb4.html" rel="bookmark">确认框的使用。弹出一个确认框，Ajax提交一个请求，刷新页面。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				视图: &lt;td&gt; @if (item.ReviewProject.DeclareState == DeclareOrReviewState.正在进行 &amp;&amp; !item.IsSubmit) { @Html.ActionLink(&quot;编辑&quot;, &quot;Edit&quot;, new { id = item.ApplicationProjectID }) &lt;text&gt; |&lt;/text&gt; @Html.ActionLink(&quot;删除&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r2jxg3.html" rel="bookmark">ajax提交富文本，内容被截断，解决方法及思路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述: 使用百度的UEditor富文本插件用于前端富文本编辑,后端使用jsp,提交普通文本没有问题,后来发现在提交某些指定文本时,数据查回的数据出现不完整现象:第一件事就是想到“垃圾编辑器”??,但是此时项目已经上线,再次重构时间成本太高,没办法只好硬着头皮-&gt;“调试”??. 解决思路: 前端获取控件内容不完整,开启前端调试:结果是有内容且完整 那完了,前端有,是不是后端没有取到值,调试了一下后端,果然: 我开始怀疑人生了??像这种情况还能怎么办,那只有一种可能了,在向服务器提交时字符被截断			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMznyAM.html" rel="bookmark" class="title">在Lazada销售产品的定价规则</a>
					<div>
						有竞争力的价格可以为产品带来更高点击率和转化率,从而实现更多销售.下面就来说说Lazada产品如何定价? 一.Lazada产品定价概述 1. 公式 Lazada产品价格=产品成本+佣金+运费+关税+其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBm26A4.html" rel="bookmark" class="title">Hibernate4&period;x之映射关系--多对多</a>
					<div>
						n-n的关联关系分为以下两类: 1.单向n-n关联关系: n-n的关联必须使用连接表 与1-n映射类似,必须为set集合元素添加key子元素,指定CATEGORIES_ITEMS表中参照CATEGOR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8O7Q0.html" rel="bookmark" class="title">12月29日 学习内容-第一个Java程序- Hello Java</a>
					<div>
						1.新建文本文档,将其扩展名改为.java   文件名myapp.java  在里面输入源代码. 2.在当前页面按住Shift点击鼠标右键,选择“在此处打开命令窗口” 3.输入“javac myapp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZOpX0.html" rel="bookmark" class="title">（转）深入理解最强桌面地图控件GMAP&period;NET --- 初用</a>
					<div>
						上一篇介绍了GMAP.NET的基本概念和一些Demo的截图,这一章主要介绍我们的代码如何使用GMAP.NET. 1.下载 http://greatmaps.codeplex.com/releases/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGXmP0.html" rel="bookmark" class="title">新浪微博客户端&lpar;28&rpar;-格式化日期显示</a>
					<div>
						DJStatus.m #import &quot;DJStatus.h&quot; #import &quot;MJExtension.h&quot; #import &quot;DJPhoto.h& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JY1wA3.html" rel="bookmark" class="title">Hdu 4497 GCD and LCM（数论）</a>
					<div>
						题目地址:http://acm.hdu.edu.cn/showproblem.php?pid=4497 思路:x%G==0,y%G==0,z%G==0,所以L%G==0,若L%G!=0则一定无解. 考 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPqWdM.html" rel="bookmark" class="title">java中Comparator的用法 -- 实现集合和数组排序</a>
					<div>
						在java中,如果要对集合对象或数组对象进行排序,需要实现Comparator接口以达到我们想要的目标. 接下来我们模拟下在集合对象中对日期属性进行排序 一.实体类Step package com.l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YR25v3.html" rel="bookmark" class="title">Drupal  views 中合并显示字段</a>
					<div>
						如图, 需要显示如下数据表格 表格的第三列是由两个字段组成的.分别是title 标题字段和body 内容字段. 默认情况下,一列只显示一个字段.如何同时显示两个呢? 这个问题难不到强大的views,要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35AoXR3.html" rel="bookmark" class="title">C&num; WeifenLuo&period;WinFormsUI&period;Docking&period;dll 应用之问题集 反射动态调用winform窗体</a>
					<div>
						反射通过命名空间.窗体名称,调用窗体 public void OpenChildForm(string formName) { Type t = Type.GetType(formName); Ass ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkkWBM.html" rel="bookmark" class="title">Centos上安装mysql配置并授权远程连接</a>
					<div>
						1.通过yum来进行mysql安装 查看yum上提供的mysql数据库可下载的版本: yum list | grep mysql 通过yum install -y mysql-server mysql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38bgb1M.html" rel="bookmark" class="title">函数实现不放在头文件的原因，及何时可以放头文件的情况</a>
					<div>
						1 .引子       在平常的 C/C++ 开发中,几乎所有的人都已经习惯了把类和函数分离放置,一个 .h 的头文件里放声明,对应的 .c 或者 .cpp 中放实现.从开始接触,到熟练使用,几乎已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLKxd3.html" rel="bookmark" class="title">墼蚊玖狼勺f40m876l</a>
					<div>
						http://weibo.com/20151030p/2308373903992521465280?odpshttp://sina.lt/dDchhttp://sina.lt/dCgbhttp://d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQL7aM.html" rel="bookmark" class="title">&lbrack;CC150&rsqb; Find a line passing the most number of points</a>
					<div>
						Problem: Given a two-dimensional graph with points on it, find a line which passes the most number o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzBaGJM.html" rel="bookmark" class="title">第五章   SqlServer之数据库三大范式</a>
					<div>
						分析: 数据库设计应遵循三大范式分别为: 第一范式:确保表中每列的原子性(不可拆分): 第二范式:确保表中每列与主键相关,而不能只与主键的某部分相关(主要针对联合主键),主键列与非主键列遵循完全函数依 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgRQK84.html" rel="bookmark" class="title">制作一个鬼程序</a>
					<div>
						1.红字处代码不理解,反正调用红字函数,效果是在桌面的最顶层显示了“ i love you” #define _CRT_SECURE_NO_WARNINGS #include&lt;stdio.h&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjdRKM.html" rel="bookmark" class="title">1小时学Python脚本</a>
					<div>
						假设我们有这么一项任务:简单测试局域网中的电脑是否连通.这些电脑的ip范围从192.168.0.101到192.168.0.200. 思路:用shell编程.(Linux通常是bash而Windows ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zpdD3.html" rel="bookmark" class="title">类练习题1：将浮点数转化为金额的类</a>
					<div>
						注:该练习题来自(Python 核心编程 第二版)第13章 练习题13-3,题目如下: 13-3.对类进行定制,写一个类,用来将浮点型值转化为金额,在本练习里,我们使用美国货币,但读者也可以自选任意货 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLxbJWM.html" rel="bookmark" class="title">eclipse将编辑栏一分为二</a>
					<div>
						今天无意中发现一个MyEclipse的功能,CTRL SHIF - 三个键一起按下时,同一个编辑窗口会一分为二.这样我们写下面代码需要参考前面代码的时候就很方便了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3raoxb0.html" rel="bookmark" class="title">&lbrack;label&rsqb;&lbrack;Chrome-Extension&rsqb; How to start Chrome Extension&amp;&num;39&semi;s development</a>
					<div>
						Firstly , you should read these two pages. https://developer.chrome.com/extensions/overview https:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MowRJbM.html" rel="bookmark" class="title">JavaScript  克隆对象</a>
					<div>
						function clone(origin) { return Object.assign({}, origin); } let aClone = { ...a }; // 等同于 let aClon ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
